package cn.com.infosec.asn1;

import java.io.InputStream;

class ConstructedOctetStream extends InputStream {
   private final ASN1StreamParser _parser;
   private boolean _first = true;
   private InputStream _currentStream;

   ConstructedOctetStream(ASN1StreamParser parser) {
      this._parser = parser;
   }

   public int read(byte[] b, int off, int len) {
      if (this._currentStream == null) {
         if (!this._first) {
            return -1;
         }

         ASN1OctetStringParser var4;
         if ((var4 = (ASN1OctetStringParser)this._parser.readObject()) == null) {
            return -1;
         }

         this._first = false;
         this._currentStream = var4.getOctetStream();
      }

      int var6 = 0;

      int var5;
      do {
         while(true) {
            var5 = off + var6;
            if ((var5 = this._currentStream.read(b, var5, len - var6)) >= 0) {
               break;
            }

            ASN1OctetStringParser var7;
            if ((var7 = (ASN1OctetStringParser)this._parser.readObject()) == null) {
               this._currentStream = null;
               if (var6 < 1) {
                  var6 = -1;
               }

               return var6;
            }

            this._currentStream = var7.getOctetStream();
         }
      } while((var6 += var5) != len);

      return var6;
   }

   public int read() {
      ASN1OctetStringParser var1;
      if (this._currentStream == null) {
         if (!this._first) {
            return -1;
         }

         if ((var1 = (ASN1OctetStringParser)this._parser.readObject()) == null) {
            return -1;
         }

         this._first = false;
         this._currentStream = var1.getOctetStream();
      }

      int var2;
      while((var2 = this._currentStream.read()) < 0) {
         if ((var1 = (ASN1OctetStringParser)this._parser.readObject()) == null) {
            this._currentStream = null;
            return -1;
         }

         this._currentStream = var1.getOctetStream();
      }

      return var2;
   }
}
